package fr.username404.snowygui.gui.feature

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.Snowy.Companion.onEvent
import fr.username404.snowygui.gui.FontUtil
import java.time.LocalDateTime

@ButtonInfo(Category.MISC)
object Clock: ButtonImpl() {
    override fun toString(): String = LocalDateTime.now().run {
        arrayOf(hour, minute, second).map {
            (it.takeIf { (it >= 10)  } ?: "0$it").toString()
        }.reduce { previous, current -> "$previous:$current"}
    }
    init {
        onEvent("HudRender") {
            if (toggled) {
                FontUtil.drawScaled(it.first() as PoseStack,
                    this@Clock.toString(),
                    5.0, 5.0,
                    0.85F, color = Colors.GOLD
                )
            }
        }
    }
}
